* Flag copying utilities		v0.00   Aug 1987  J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_wstatus'
	include 'dev8_keys_wwork'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_err'
*
	xref	bem_achp
	xref	bem_sia2
*
	xdef	bed_clfl
	xdef	bed_cafl
	xdef	bed_rlfl
	xdef	bed_rafl
	xdef	bed_rclf
	xdef	bed_rcaf
	xdef	bed_ccdf
	xdef	bed_rcdf
*
cflgreg reg	d3-d7/a1-a3
*
*	Set up and check for copying from/to the loose item flag array
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D2				index multiplier
*	D4				number of loose items
*	A0	array descriptor		preserved
*	A1				first element
*	A4	working definition		preserved
*
bec_slfl
	cmp.w	#1,4(a6,a0.l)	; one-dimensional array
	bne.s	bes_exbp		; not 1-d, problem
	move.w	ww_nlitm(a4),d4 ; number of loose items expected
	move.w	d4,d0
	subq.w	#1,d0		; less one...
	cmp.w	6(a6,a0.l),d0	; ...should be max index
	bne.s	bes_exbp		; it isn't, wonderful
	move.w	8(a6,a0.l),d2	; get index multiplier
	add.w	d2,d2		; each element is two bytes long
	move.l	0(a6,a0.l),a1	; and point to...
	add.l	bv_vvbas(a6),a1 ; ...first element 
*
	bra.s	bes_exok
*
*	Set up and check for copying from/to the application window flags
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D2				row index multiplier
*	D3				column index multiplier
*	D4				number of rows
*	D5				number of columns
*	A0	array descriptor		preserved
*	A1				first element
*	A4	sub-window definition		preserved
*
bec_safl
	cmp.w	#2,4(a6,a0.l)	; two-dimensional array
	bne.s	bes_exbp		; not 2-d, problem
	move.w	wwa_nrow(a4),d4 ; number of rows expected
	move.w	wwa_ncol(a4),d5 ; and number of columns
*
	move.w	d4,d0		; number of rows...
	subq.w	#1,d0		; ...less one...
	cmp.w	6(a6,a0.l),d0	; ...should be first max index
	bne.s	bes_exbp		; it isn't, wonderful
*
	move.w	d5,d0		; compare columns...
	subq.w	#1,d0
	cmp.w	10(a6,a0.l),d0	; ...and second max index
	bne.s	bes_exbp		; hey ho, so much for that
*
	move.w	8(a6,a0.l),d2	; get row index multiplier
	move.w	12(a6,a0.l),d3	; and column
	add.w	d2,d2
	add.w	d3,d3		; each element is two bytes long
	move.l	0(a6,a0.l),a1	; and point to...
	add.l	bv_vvbas(a6),a1 ; ...first element 
*
bes_exok
	moveq	#0,d0
bes_exit
	rts
bes_exbp
	moveq	#err.ipar,d0
	bra.s	bes_exit
*
*	Set up and copy loose item flags.  These are just after the
*	status area, so we have to have enough space for this too.
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D1				1 if any change bit set, else 0
*	D2/D4				smashed
*	A0	flag array descriptor		smashed
*	A1				smashed
*	A4	working definition		preserved
*
bed_rclf
bed_clfl
	movem.l cflgreg,-(sp)
*
	bsr	bec_slfl		; set up
	bne.s	bec_exit
	move.l	ww_wstat(a4),a0 ; point to status area
*
	lea	ws_litem(a0),a0 ; point to first status byte
	moveq	#0,d1		; collect change bits
	bra.s	bec_clfe
bec_clfl
	move.b	1(a6,a1.l),d0	; get a flag
	move.b	d0,(a0)+		; copy it
	or.b	d0,d1		; accumulate and...
	bclr	#wsi..chg,1(a6,a1.l)	; ...clear its change bit
	add.w	d2,a1		; point to next array element
bec_clfe
	dbra	d4,bec_clfl
	and.b	#1,d1		; set only the change bit
bec_exok
	moveq	#0,d0
bec_exit
	movem.l (sp)+,cflgreg
	rts
bec_exbp
	moveq	#err.ipar,d0
	bra.s	bec_exit
	page
*
*	Copy loose flags back into the array
*
bed_rlfl
	movem.l cflgreg,-(sp)
*
	bsr	bec_slfl		; point to array
	bne	bec_exit
	move.l	ww_wstat(a4),a0 ; point to status area
bec_retl
	lea	ws_litem(a0),a0 ; point to first status byte
	bra.s	bec_rlfe
bec_rlfl
	move.b	(a0)+,1(a6,a1.l)	; copy a flag
	add.w	d2,a1		; point to next array element
bec_rlfe
	dbra	d4,bec_rlfl
	bra	bec_exok
	page
*
*	Set up and copy an application sub-window's flags.
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D1				1 if any change bit set, else 0
*
bed_rcaf
	movem.l cflgreg,-(sp)
*
	bsr	bec_safl		; set up a bit
	bne	bec_exit
	move.l	wwa_mstt(a4),a0 ; point to flags
	bra.s	bec_cpya		; and copy them
*
bed_cafl
	movem.l cflgreg,-(sp)
*
	bsr	bec_safl		; set up the array stuff
	bne	bec_exit		; whoops
*
	move.w	d4,d1		; space for flags is number of rows...
	mulu	d5,d1		; ...times number of columns
	jsr	bem_achp(pc)		; get the space
	bne	bec_exit		; OK, don't get the space
	move.l	a0,wwa_mstt(a4) ; point to menu status block
*
*	Copy the flags from an array
*
bec_cpya
	move.w	d3,d0		; column index increment*ncols
	mulu	d5,d0		; makes total increment in a row
	sub.w	d0,d2		; so amount to increment at end of row
	moveq	#0,d0		; assume no change bits set
	bra.s	bec_crwe
bec_crwl
	move.w	d5,d1
	bra.s	bec_ccle
bec_ccll
	move.b	1(a6,a1.l),(a0) ; copy a flag
	or.b	(a0)+,d0		; accumulate and...
	bclr	#wsi..chg,1(a6,a1.l)	; ...clear its change bit
	add.w	d3,a1		; next flag in this row
bec_ccle
	dbra	d1,bec_ccll
	add.w	d2,a1		; next row
bec_crwe
	dbra	d4,bec_crwl
	moveq	#1,d1		; change bit is bottom one
	and.b	d0,d1		; get accumulated change bit
*
	bra	bec_exok
*
*	Copy the flags from a menu status area back into an array
*
bed_rafl
	movem.l cflgreg,-(sp)
	bsr	bec_safl		; set up to point to array
	bne	bec_exit
	move.l	wwa_mstt(a4),a0 ; and to flags
bec_reta
	move.w	d3,d0		; column index increment*ncols
	mulu	d5,d0		; makes total increment in a row
	sub.w	d0,d2		; so amount to increment at end of row
	bra.s	bec_rrwe
bec_rrwl
	move.w	d5,d1
	bra.s	bec_rcle
bec_rcll
	move.b	(a0)+,1(a6,a1.l)	; copy a flag back
	add.w	d3,a1		; next flag in this row
bec_rcle
	dbra	d1,bec_rcll
	add.w	d2,a1		; next row
bec_rrwe
	dbra	d4,bec_rrwl
*
	bra	bec_exok
*
*	Copy a control definition from an nx3 integer array
*
*	Registers:
*	      Entry			Exit
*	D1/D2				smashed
*	D6	max number of sections		preserved
*	A0				smashed
*	A1	control block		preserved
*	A3	NT entry of array		preserved
*
cdefreg reg	d3/d7/a0/a1
*
bed_scdf
	move.w	d6,d7		; this many sections required
	addq.w	#1,d7		; plus "number in use" row
	moveq	#2,d3		; by three (0..2)
	jmp	bem_sia2(pc)		; set up 2-d integer array
*
bed_ccdf
	movem.l cdefreg,-(sp)
	bsr	bed_scdf		; set up
	bne.s	bef_exit		; ...oops
	move.w	0(a6,a0.l),d7	; actual number of sections
	cmp.w	d3,d7		; compare with max number
	bhi.s	bef_exbp
	move.w	d7,(a1)+		; fill it in
	add.w	d2,a0
	move.w	0(a6,a0.l),d3	; get change flag
	sne	d3			; make it 0 or $ff
	add.w	d2,a0
	add.w	d2,a0		; end of row
	add.w	d1,a0		; next row
	bra.s	bef_cdfe
bef_cdfl
	moveq	#2,d0
bef_cspl
	move.w	(a6,a0.l),(a1)+ ; fill in from array
	add.w	d2,a0		; next column
	dbra	d0,bef_cspl		; until one section done
	add.w	d1,a0
bef_cdfe
	dbra	d7,bef_cdfl		; until all sections done
	move.b	d3,d1		; return change flag
*
bef_exok
	moveq	#0,d0
bef_exit
	movem.l (sp)+,cdefreg
	rts
bef_exbp
	moveq	#err.ipar,d0
	bra.s	bef_exit
*
*	Copy control information back to array
bed_rcdf
	movem.l cdefreg,-(sp)
	bsr	bed_scdf		; set up
	bne.s	bef_exit		; ...oops
	move.w	(a1)+,d7		; actual number of sections
	cmp.w	d3,d7
	bhi	bef_exbp		; too many
	move.w	d7,(a6,a0.l)		; fill it in
	add.w	d2,a0
	add.w	d2,a0
	add.w	d2,a0		; end of row
	add.w	d1,a0		; next row
	bra.s	bef_rdfe
bef_rdfl
	moveq	#2,d0
bef_rspl
	move.w	(a1)+,(a6,a0.l) ; fill in from control block
	add.w	d2,a0		; next column
	dbra	d0,bef_rspl		; until one section done
	add.w	d1,a0
bef_rdfe
	dbra	d7,bef_rdfl		; until all sections done
	bra.s	bef_exok
*
	end
