* Routines for application sub-windows	v0.00   Aug 1987  J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_err'
	include 'dev8_mac_assert'
	include 'dev8_keys_wwork'
	include 'dev8_keys_wstatus'
	include 'dev1_asm_qptr_keys'
*
	xref	ut_lfla1
	xref	ut_retfp
*
	xref	bem_chpn
	xref	bem_gsiz
	xref	bem_gasz
	xref	bem_achp
	xref	bem_sri6
	xref	bem_siat
	xref	bem_sia2
	xref	bem_giat
	xref	bem_gxyw
	xref	bem_gxyb
	xref	bem_gchr
	xref	bem_gobj
	xref	bem_rchp
*
	xdef	bem_gdat
	xdef	bem_gfdt
	xdef	bem_cvia
	xdef	be_reths
*
	xdef	be_mkaot
	xdef	be_mkcdf
	xdef	be_mkast
	xdef	be_mkrwt
*
*	Get enough space for a data structure.	The name table entry
*	must be that of a 2-d integer array, whose first dimension gives
*	the number of items in the data structure.  If the array
*	is one-dimensional then there is only one item in the data
*	structure.
*
*	Registers:
*	      Entry			Exit
*	D0	overhead			error code
*	D1	(array type)			smashed
*	D6	element size			preserved
*	D7				number of elements
*	A0				array descriptor
*	A3	NT entry			preserved
*	A5				space reserved
*
bem_gfdt
	move.l	d0,d7
	move.w	#$0302,d1
	jsr	bem_gasz(pc)		; get size of specified type array
	bne.s	beg_exit		; failed
	move.l	a0,a5			; keep descriptor
	bra.s	bem_rovh		; and enter get size routine
*
bem_gdat
	move.l	d0,d7
	jsr	bem_gsiz(pc)		; get array size
	bne.s	beg_exit		; bonk
	move.l	a0,a5			; save descriptor
	cmp.w	#1,4(a6,a0.l)		; is it a 1-d array?
	bne.s	bem_rovh		; no, OK
	moveq	#1,d1			; yes, one item only then
bem_rovh
	move.l	d7,d0			; restore overhead
	move.w	d1,d7			; copy size
	beq.s	beg_exip		; zero ain't allowed
	mulu	d6,d1			; space for items
	add.l	d0,d1			; plus overhead
	jsr	bem_achp(pc)		; get the space
	exg	a0,a5			; point to space and descriptor
beg_exit
	rts
beg_exip
	moveq	#err.ipar,d0
	bra.s	beg_exit
*
*	Make an application object table.
*
be_mkaot
	move.l	a5,d5			; keep pointer to end of parameters
	moveq	#4,d7			; we need more than 4 parameters
	jsr	bem_chpn(pc)
	sub.l	a5,a5			; flag no heap yet
	bge.s	bem_exbp		; we don't have enough parameters...
*
	addq.l	#8,a3			; second parameter has size
	moveq	#wwm.olen,d6		; space required for an object
	moveq	#wwa.elen+mol.hdrl,d0	; plus space for item attributes
	bsr	bem_gdat		; get some heap
	bne.s	bem_exit		; ...oops
	subq.l	#8,a3			; point back to first parameter
	move.w	d7,mol_numo(a5) 	; keep number of items in table
*
*	Get item attributes
*
	bsr	bem_cvia		; get item attributes
	bne.s	bem_exit		; ...oops
*
*	Fill in the table from the arrays passed
*
tbst	equ	mol.hdrl+wwa.elen
*
	lea	wwm_xjst+tbst(a5),a4	; fill in justification
	addq.l	#8,a3
	jsr	bem_gxyb(pc)		; compressing two words into a byte
	bne.s	bem_exit
*
	lea	wwm_skey+tbst(a5),a4	; fill in select keys
	addq.l	#8,a3
	jsr	bem_gchr(pc)		; get characters from string
	bne.s	bem_exit
*
	lea	wwm_type+tbst(a5),a4	; fill in type/object/action
	lea	mol_hfre(a5),a5 	; strings to user heap
	addq.l	#8,a3
	jsr	bem_gobj(pc)
	lea	-mol_hfre(a5),a5
	bne.s	bem_exit
*
	moveq	#0,d0
bem_exit
	tst.l	d0			; OK?
	beq.s	bem_rtad		; yes
*
	move.l	d0,-(sp)
	move.l	a5,d0		; is there any heap?
	beq.s	bem_nrhp		; no
	move.l	d0,a0
	jsr	bem_rchp(pc)		; yes, unlink and return it
bem_nrhp
	move.l	(sp)+,d0		; restore error
bem_exnr
	rts
bem_exbp
	moveq	#err.ipar,d0
	bra.s	bem_exit
*
be_reths
bem_rtad
	jsr	bem_sri6(pc)		; ensure we've space
	addq.l	#6,bv_rip(a6)
	move.l	a5,d1		; set D1 to base of table
	jsr	ut_lfla1(pc)		; and push D1 (floated) onto RI stack
	jmp	ut_retfp(pc)		; and return with 
	page
*
*	Get the attributes required for a control definition
*
be_mkcdf
	move.w	ca.gtint,a2
	jsr	(a2)		; get some integers
	sub.l	a5,a5	 
	bne	bem_exit		; failed
	subq.w	#4,d3		; four of them
	bne	bem_exbp
*
	moveq	#ctd.hdrl,d1		; we want this much space
	move.w	0(a6,a1.l),d0	; plus space for this many...
	mulu	#wss.ssln,d0		; ...control sections
	add.l	d0,d1
	jsr	bem_achp(pc)		; get enough heap for the definition
	bne	bem_exit		; couldn't
	move.l	a0,a5
	assert	ctd_maxs,ctd_psac-2
	move.l	0(a6,a1.l),ctd_maxs(a5) ; fill in max sections and arrow colour
	assert	ctd_psbc,ctd_pssc-2
	move.l	4(a6,a1.l),ctd_psbc(a5) ; and bar colours
	addq.l	#8,bv_rip(a6)
	bra	bem_exit		; and return
*
*	Get item attributes
*
bem_cvia
	jsr	bem_sri6(pc)
	jsr	bem_siat(pc)		; set up from next parameter
	bne.s	bec_exit		; (help)
	lea	mol.hdrl(a5),a2 ; where to put attributes
	jsr	bem_giat(pc)		; get item attributes
bec_exit
	addq.l	#6,bv_rip(a6)
	tst.l	d0
	rts
*
*	Make a spacing table
*
be_mkast
	moveq	#1,d7		; at least one parameter?
	jsr	bem_chpn(pc)
	move.l	a5,a4
	sub.l	a5,a5		; flag no heap
	bgt	bem_exbp		; not enough parms
*
	moveq	#wwm.slen,d6		; spacings are this big
	moveq	#msl.hdrl,d0		; with this overhead
	bsr	bem_gdat		; get some space
	bne	bem_exit		; don't then
	move.w	d7,msl_numo(a5) ; fill in number of elements
*
*	Get index item parameters, if any
*
	addq.l	#8,a3		; skip array
	cmp.l	a3,a4		; any more parameters?
	beq.s	bem_nois		; nope
	exg	a4,a5		; point to last parm again
	move.w	ca.gtint,a2		; get some integers
	jsr	(a2)
	bne	bem_exit		; all wrong
	subq.w	#2,d3		; two of them?
	bne	bem_exbp		; nope
	move.l	a4,a5
	assert	msl_isiz,msl_ispc-2
	move.l	0(a6,a1.l),msl_isiz(a5) ; fill in index item size and spacing
	addq.l	#4,bv_rip(a6)	; pop stack
*
*	Fill in spacing table
*
stbs	equ	msl.hdrl
*
bem_nois
	subq.l	#8,a3		; point to array
	moveq	#wwm.slen,d6		; restore spacing
	lea	wwm_size+stbs(a5),a4	; fill in size and spacing
	jsr	bem_gxyw(pc)
	bra	bem_exit		; and that's it!
	page
*
*	Make a row table: each row must have the same number of columns in it.
*
be_mkrwt
	moveq	#2,d7
	jsr	bem_chpn(pc)		; two parameters
	sub.l	a5,a5
	bne	bem_exbp		; not
*
*	Get data on objects themselves
*
	lea	8(a3),a5		; get first parameter
	move.w	ca.gtlin,a2
	jsr	(a2)		; get some long integers
	sub.l	a5,a5
	bne	bem_exit		; don't
	move.l	0(a6,a1.l),a4	; point to object table
	move.w	mol_numo(a4),d5 ; number of objects
	addq.l	#4,bv_rip(a6)	; tidy stack
*
*	Get space for row list
*
	addq.l	#8,a3		; point to array
	moveq	#wwm.rlen,d6		; entry length
	moveq	#mol.hdrl+rwl.hdrl,d0	; overhead
	bsr	bem_gdat		; get space
	bne	bem_exit
*
	move.w	d7,mol.hdrl+rwl_numr(a5) ; fill in number of rows
	move.l	a4,mol.hdrl+rwl_obtb(a5) ; and object table pointer
*
*	Fill in row list: each pair of array elements gives the
*	item numbers of the first and one-after-last objects in the row.
*
	moveq	#1,d3		; n by 0..1 array
	jsr	bem_sia2(pc)		; set up for a 2-d array
	bne	bem_exit		; clang
	lea	0(a0,d2.w),a2
	move.w	0(a6,a2.l),d0	 ; last item of row...
	sub.w	0(a6,a0.l),d0	 ; ...less first...
	move.w	d0,mol_numo(a5)  ; ...is number of columns
	lea	mol.hdrl+rwl.hdrl(a5),a2 ; where the row table really starts
	add.w	#mol.hdrl+wwa.elen,a4	 ; where the first object is
	bra.s	bem_srle
bem_srll
	move.w	0(a6,a0.l),d0	; start item number
	cmp.w	d0,d5		; too big?
	bcs	bem_exbp		; yes
	move.w	d0,d4		; keep it
	mulu	#wwm.olen,d0		; it's this far into the table
	add.l	a4,d0		; so this is its absolute address
	move.l	d0,(a2)+
*
	add.w	d2,a0		; next element is...
	move.w	0(a6,a0.l),d0	; ...end item number
	cmp.w	d0,d5		; too big?
	bcs	bem_exbp		; yes
	sub.w	d0,d4		; get start-end
	add.w	mol_numo(a5),d4 ; should be same as before
	bne	bem_exbp		; wrong
	mulu	#wwm.olen,d0		; it's this far into the table
	add.l	a4,d0		; so this is its absolute address
	move.l	d0,(a2)+
*
	add.w	d2,a0		; next column...
	add.w	d1,a0		; ...and next row
bem_srle
	dbra	d3,bem_srll
	moveq	#0,d0		; no problems
	bra	bem_exit
*
	end
