* Make header for application sub-window  v0.00   Aug 1987  J.R.Oakley  QJUMP
* 2020-08-19  Bug fixes for indexes items data structure (A.Haoui)
*
        section prog
*
        include 'dev8_keys_qdos_sms'
        include 'dev8_keys_err'
        include 'dev8_mac_assert'
        include 'dev8_keys_wwork'
        include 'dev1_asm_qptr_keys'
*
        xref    ut_lfla1
        xref    ut_retfp
*
        xref    tv_ehit
        xref    wm_mdral
        xref    wm_mhit
        xref    wm_pansc
*
        xref    bem_chpn
        xref    bem_achp
        xref    bem_sri6
        xref    bem_rchp
        xref    bem_cgpt
        xref    bem_swat
        xref    bem_gwat
        xref    bem_glin
        xref    bem_gfdt
        xref    bem_cpya
        xref    bem_cpyi
*
        xref    be_reths
*
        xdef    be_mkapw
        xdef    be_mkawt
*
*       Set up the application sub-window header
*
bew_exbp
        moveq   #err.ipar,d0
bew_exit
        tst.l   d0
        beq.s   bew_exrt		; OK exit, return answer
*
        move.l  d0,d3
        move.l  a4,d0		; any heap to return?
        beq.s   bew_nort
        move.l  a4,a0
        jsr     bem_rchp(pc)		; throw back heap
        sub.l   a4,a4
bew_nort
        move.l  d3,d0
bew_exnr
        rts			; and exit with error
*
bew_exrt
        move.l  a4,a5
        jmp     be_reths		; return the heap start address
*
be_mkapw
        sub.l   a4,a4		; no heap
        moveq   #13,d7
        jsr     bem_chpn(pc)		; must have 13 parameters
        beq.s   bew_bigw		; we do, 'tis a ninORmous window
        cmp.w   #4,d0		; not, could it be four?
        bne     bew_exbp		; should be, but isn't
*
        moveq   #wwa.blen,d1		; short header is this big
        bsr.s   bew_head		; get the header
        bne     bew_exit
        lea     tv_ehit(pc),a0	; use special hit routine
        move.l  a0,wwa_hit(a4)
        bra     bew_exit		; and return
*
*       Make the header
*
bew_head
        jsr     bem_achp(pc)		; allocate space for header
        bne     bew_exit		; no room
        move.l  a0,a4		; point to sub-window definition
*
        jsr     bem_swat(pc)		; set up for window definition
        bne.s   bew_exit		; bomb
        lea     wwa_xsiz(a4),a2	; where to put...
        jsr     bem_gwat(pc)		; ...the window attributes
*
        addq.l  #8,a3		; next parameter
        jsr     bem_swat(pc)		; set up for window attributes
        bne.s   bew_exit		; boing
        lea     wwa_watt(a4),a2	; point to and...
        jsr     bem_gwat(pc)		; ...get the window attributes
*
        addq.l  #8,a3		; next parameter
        jsr     bem_cgpt(pc)		; is a pointer
        beq.s   bew_gkey		; (but it's zero)
        move.l  a1,wwa_pspr(a4)	; to the pointer sprite
*
bew_gkey
        addq.l  #8,a3
        lea     8(a3),a5		; get just one...
        move.w  ca.gtstr,a2
        jsr     (a2)		; ...string
        bne     bew_exit
        move.w  0(a6,a1.l),d0 	; how long is it?
        beq.s   bew_pstr		; zilch, just pop it
        move.b  2(a6,a1.l),wwa_skey(a4) ; fill in select key
bew_pstr
        addq.w  #3,d0		; skip length and string and pad
        and.w   #$fffe,d0
        add.w   d0,a1		; back to BOS
        move.l  a1,bv_rip(a6)
*
        moveq   #0,d0
        rts
*
*       Make a real big menu sub-window
*
bew_bigw
        move.l  #wwa.blen+2*wwa.clen+wwa.mlen,d1
        bsr     bew_head		; allocate space and make header
        bne     bew_exit		; donk
*
*       Set up control sections
*
        addq.l  #8,a3
        lea     9*8(a3),a5		; we still have 9 parameters to go
        jsr     bem_cgpt(pc)		; get pointer to control definition
        beq.s   bew_gycd		; none, try y
        assert  ctd_maxs,0
        move.w  (a1)+,wwa_nxsc(a4)	; fill in max x control sections
        lea     wwa_psac(a4),a0	; point to colours
        assert  wwa_psac,wwa_psbc-2,wwa_pssc-4
        assert  ctd_psac,ctd_psbc-2,ctd_pssc-4
        move.w  (a1)+,(a0)+
        move.w  (a1)+,(a0)+		; fill in colours
        move.w  (a1)+,(a0)+
        assert  ctd_pssc+2,ctd_nsec
        move.l  a1,wwa_part(a4)	; and pointer to control block
bew_gycd
        addq.l  #8,a3
        jsr     bem_cgpt(pc)		 ; get pointer to y control definition
        beq.s   bew_goff		 ; none, get offsets
        move.w  (a1)+,wwa_nysc(a4)	 ; fill in max y control sections
        lea     wwa_psac+wwa.clen(a4),a0 ; point to colours
        assert  wwa_psac,wwa_psbc-2,wwa_pssc-4
        assert  ctd_psac,ctd_psbc-2,ctd_pssc-4
        move.w  (a1)+,(a0)+
        move.w  (a1)+,(a0)+		 ; fill in colours
        move.w  (a1)+,(a0)+
        assert  ctd_pssc+2,ctd_nsec
        move.l  a1,wwa_part+wwa.clen(a4) ; and pointer to control block
*
bew_goff
        addq.l  #8,a3
        lea     2*8(a3),a5		; get two...
        move.w  ca.gtint,a2		; ...integers
        jsr     (a2)
        bne     bew_exit		; whoopsie
        assert  wwa_xoff,wwa_yoff-2
        move.l  0(a6,a1.l),wwa_xoff(a4) ; fill in offsets
        addq.l  #4,a1
        move.l  a1,bv_rip(a6) 	; unwind RI stack
*
*       Two spacing lists, both must exist: the index spacings may not,
*       but it doesn't hurt to copy them.  The number of items in
*       the spacing lists must correspond exactly with the number of
*       index items and columns/rows.
*
        move.l  a5,a3
        lea     5*8(a3),a5		; there are still 5 parameters left
        jsr     bem_cgpt(pc)		; point to x spacing list
        beq     bew_exbp		; we must have one
        assert  msl_isiz,msl_ispc-2,0
        assert  wwa_insz,wwa_insp-2
        move.l  (a1)+,wwa_insz(a4)	; fill in index spacings
        assert  msl_numo,4
        move.w  (a1)+,wwa_ncol(a4)	; number of columns
        assert  msl.hdrl,6
        move.l  a1,wwa_xspc(a4)	; and pointer to x spacing list
*
        addq.l  #8,a3
        jsr     bem_cgpt(pc)		; point to y spacing list
        beq     bew_exbp		; we must have one
        assert  msl_isiz,msl_ispc-2,0
        assert  wwa_insz,wwa_insp-2
        move.l  (a1)+,wwa_insz+wwa.clen(a4) ; fill in index spacings
        assert  msl_numo,4
        move.w  (a1)+,wwa_nrow(a4)	; number of rows
        assert  msl.hdrl,6
        move.l  a1,wwa_yspc(a4)	; pointer to y spacing list
*
*       Index item tables may not be present.  When they are, they
*       are preceded by index item attributes.
*
        addq.l  #8,a3
        jsr     bem_cgpt(pc)
        beq.s   bew_cyit		; no x index, check y
        addq.l  #mol_numo,a1		; skip heap header
        move.w  (a1)+,d0		; number of items
        cmp.w   wwa_ncol(a4),d0	; same as spacing?
        bne     bew_exbp		; no, problem
        assert  mol.hdrl,mol_numo+2
        assert  wwa_attr-wwa_curw,wwa_iiat-wwa_icur
;;        lea     wwa_insz(a4),a0	; where they go (AH)
	lea     wwa_icur(a4),a0		; where they should go (AH)
        jsr     bem_cpyi(pc)		; copy index attributes bor+unav
*
;;        add.w   #wwa.alen,a1		; skip over unused attributes to table (AH)
        add.w   #wwa.elen,a1		; this is the real attributes length (AH)
        move.l  a1,wwa_xind(a4)	; pointer to index table
*
bew_cyit
        addq.l  #8,a3
        jsr     bem_cgpt(pc)
        beq.s   bew_crow		; no y index, do row list
        addq.l  #mol_numo,a1		; skip heap header
        move.w  (a1)+,d0		; number of items
        cmp.w   wwa_nrow(a4),d0	; same as spacing?
        bne     bew_exbp		; no, problem
        assert  mol.hdrl,mol_numo+2
        assert  wwa_attr-wwa_curw,wwa_iiat-wwa_icur
;;        lea     wwa_insz+wwa.clen(a4),a0  ; where they go (AH)
	lea     wwa_icur+wwa.clen(a4),a0  ; where they should go (AH)
        jsr     bem_cpyi(pc)		  ; copy index attributes bor+unav
*
;;        add.w   #wwa.alen,a1		; skip over unused attributes to table (AH)
        add.w   #wwa.elen,a1		; this is the real attributes length (AH)
        move.l  a1,wwa_yind(a4)	; pointer to index table
*
*       Lastly get the row list
*
bew_crow
        addq.l  #8,a3
        jsr     bem_cgpt(pc)		; get pointer to row list
        beq     bew_exbp		; there ought to be one
        addq.l  #mol_numo,a1		; point to number of columns/rows
        assert  mol_numo+2,mol.hdrl
        assert  rwl_numr,0
        move.l  (a1)+,d0		; get both
        cmp.l   wwa_ncol(a4),d0	; both must be the same
        bne     bew_exbp		; what a wally
*
        assert  rwl_obtb,2
        move.l  (a1),d0		; here's a pointer
        beq     bew_exbp		; there'd better be one
        bclr    #0,d0
        bne     bew_exbp		; and it must be even
        move.l  d0,a0
        add.w   #mol.hdrl,a0		; point to object table's attributes
        lea     wwa_iatt(a4),a2	; where to put them
        exg     a0,a1
        jsr     bem_cpya(pc)		; copy them
        exg     a0,a1
        add.w   #rwl.hdrl-rwl_obtb,a1	; skip to start of row list
        move.l  a1,wwa_rowl(a4)	; fill in pointer to row list
*
*       Everything's OK, fill in fixed stuff
*
        lea     wm_mdral(pc),a0
        move.l  a0,wwa_draw(a4)
        lea     wm_mhit(pc),a0
        move.l  a0,wwa_hit(a4)
        lea     wm_pansc(pc),a0
        move.l  a0,wwa_ctrl(a4)
*
        move.l  a4,a5		; return base address
        moveq   #0,d0
        bra     bew_exit
*
*       Make an application sub-window table
*
be_mkawt
        moveq   #1,d7
        jsr     bem_chpn(pc)		; exactly one parameter
        sub.l   a5,a5
        bne     bew_exbp		; wrong
*
        jsr     bem_sri6(pc)		; first make space on RI stack
*
        moveq   #4,d6		; list elements are four bytes long
        moveq   #6,d0		; with a six byte overhead
        jsr     bem_gfdt(pc)		; get size and space
        bne     bew_exit		; ...oops
        move.w  d7,(a5)		; number of entries
        beq     bew_exbp		; not allowed none
        cmp.w   #1,4(a6,a0.l) 	; one dimensional array?
        bne     bew_exbp		; no, wrong
        moveq   #6,d2		; element spacing is...
        mulu    8(a6,a0.l),d2 	; ...this much (f.p.'s are six bytes)
        move.l  0(a6,a0.l),a0 	; first element is...
        add.l   bv_vvbas(a6),a0	; ...here
*
        lea     2(a5),a4		; point to first item in table...
        move.l  bv_rip(a6),a1 	; ...and TOS
        bra.s   bem_awte
bem_awtl
        jsr     bem_glin(pc)		; get a long integer
        bne     bew_exit		; zut!
        move.l  d3,(a4)+		; fill it in
bem_awte
        dbra    d7,bem_awtl
        addq.l  #6,bv_rip(a6) 	; return RI space
*
        move.l  a5,a4
        moveq   #0,d0		; done, no errors
        bra     bew_exit
*
        end
