* Read pointer through window manager	v0.00   Aug 1987  J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_keys_wwork'
	include 'dev8_keys_wstatus'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_wman'
*
	xref	bem_chpn
	xref	bem_ciar
	xref	bem_gsiz
*
	xref	bed_rdli
	xref	bed_rdaw
	xref	bed_gwmv
	xref	bed_rlfl
	xref	bed_rafl
	xref	bed_rcdf
*
	xdef	be_rdptr
	xdef	be_rdptrt
*
rdptreg reg	a3/a5

*** wl
stk_a5	equ	$0c
*** end wl

*

be_rdptrt
	movem.l rdptreg,-(sp)
***** wl
	subq.l	#4,a7
	pea	$38(a3) 	; point to flags (after pointers and returns)
	moveq	#6,d7		; we need at least six parameters

	jsr	bem_chpn(pc)		; do we have them?
	bge	ber_exbp		; nope
	lea	$18(a3),a3	; point to event param
	lea	$10(a3),a5	; just get event and timeout
	move.w	ca.gtint,a2
	jsr	(a2)
	bne	ber_exit       ; didn't
	move.l	8(a7),a3	; get pram pointer back
	move.l	(a6,a1.l),d1	; event% | timeout%
	not.w	d1
	move.l	d1,4(a7)
	beq	ber_exbp	; timeout mustn't be infinite
	bra.s	ber_comn	; continue

be_rdptr
	movem.l rdptreg,-(sp)
*
	clr.l	-(a7)
	pea	$30(a3) 	; point to flags (after pointers and returns)

**** end wl

	moveq	#5,d7		; we need at least five parameters
	jsr	bem_chpn(pc)		; do we have them?
	bge	ber_exbp		; nope
ber_comn			; **** wl
	lea	8(a3),a5		; just get first
	move.w	ca.gtlin,a2
	jsr	(a2)		; get pointer to window definition
	bne	ber_exit		; a duff one
	move.l	0(a6,a1.l),a4	; point to the window
	move.l	stk_a5(sp),a5
*
*** wl
	move.l	(a7),a3 	; skip pointer and returns
*** end wl
	tst.w	ww_nlitm(a4)		; any loose items?
	beq.s	ber_rdap		; no, no need to re-draw them then
	moveq	#-1,d3		; force selective re-draw
	jsr	bed_rdli(pc)		; re-draw loose items
	bne	ber_exit		; karangg!!!
	addq.l	#8,a3		; skip to next parameter
*
ber_rdap
	move.w	ww_nappl(a4),d7 ; number of application sub-windows
	move.l	ww_pappl(a4),a1 ; where they are
	bra.s	ber_appe
ber_appl
	move.l	(a1)+,a2		; next sub-window
	tst.l	wwa_draw(a2)		; re-drawable?
	beq.s	ber_appe		; no
	cmp.l	a3,a5		; off end of parameters yet?
	ble	ber_exbp		; yes, bother
	moveq	#-1,d3		; don't re-draw all
	move.l	d7,-(sp)
	jsr	bed_rdaw(pc)		; re-draw application window
	move.l	(sp)+,d7
	tst.l	d0			; did the re-draw work?
	bne	ber_exit		; no, bother
ber_appe
	dbra	d7,ber_appl
*
*	Read the pointer until an event occurs or an exit item is hit
*
	move.l	ww_chid(a4),a0	; get window's ID
	jsr	bed_gwmv(pc)		; and thus the window manager vector
	bne	ber_exit
	move.l	bv_rip(a6),a5	; where to put some answers
	moveq	#-1,d0
	move.l	d0,0(a6,a5.l)	; set to -1 for now
	move.l	ww_wstat(a4),a1 ; get from status area...
	move.l	wsp_xpos(a1),d7 ; ...the current pointer position
**** wl
	move.l	4(a7),d3
	beq.s	ber_rdpt
	not.w	d3
	move.l	d3,d2
	rol.l	#8,d2		; job events
	cmpi.l	#'1.50',(a2)
	blt	ber_exbp
	jsr	wm.rptrt(a2)
	bra.s	ber_read

ber_rdpt
	jsr	wm.rptr(a2)	; read the pointer
ber_read			; ptr was read
	cmp.l	#-1,d0			; not complete?
	blt	ber_exit		; the pointer is illegible
	tst.b	bv_brk(a6)	; break hit?
	bgt	ber_exit
	move.l	a5,a1		; point to top of stack
	movem.l 8(sp),rdptreg
**** end wl


	addq.l	#8,a3		; point to first return parameter
	bsr	ber_let 	; assign that
	bsr	ber_let 	; and the next
	move.l	ww_wstat(a4),a2 ; point to status area
	move.w	wsp_evnt(a2),d0 ; get window event vector
	bsr	ber_ld0 	; assign it
**** wl
	move.l	(a7),a3
	suba.w	#16,a3
**** end wl

	move.w	wsp_xpos(a2),d0
	bsr.s	ber_ld0 	; and position
	move.w	wsp_ypos(a2),d0
	bsr.s	ber_ld0
*
*	Now copy flag values back into the arrays: first the loose flags...
*
	move.w	ww_nlitm(a4),d7 ; number of flags to return
	beq.s	ber_rtaf		; none whatever
	jsr	bem_gsiz(pc)		; must be an integer array, get size
	bne.s	ber_exit
	cmp.w	d7,d1		; must have this many elements
	bne.s	ber_exbp
	jsr	bed_rlfl(pc)		; copy flags
	bne.s	ber_exit
	addq.l	#8,a3
*
*	...and now the application windows
*
ber_rtaf
	move.l	ww_pappl(a4),a2 ; point to application window list
	move.w	ww_nappl(a4),d7 ; there must be this many
	bra.s	ber_apre
ber_appw
	move.l	(a2)+,a4		; next sub-window
	tst.l	wwa_draw(a4)		; has it flags?
	beq.s	ber_apre		; nope
*
	cmp.l	a3,a5
	ble.s	ber_exbp
	jsr	bem_ciar(pc)		; find array
	bne.s	ber_exit		; karangg!
	jsr	bed_rafl(pc)		; copy application flags
	bne.s	ber_exit		; ...oops
	addq.l	#8,a3
*
	move.l	wwa_part(a4),a1 ; x control block
	move.w	wwa_nxsc(a4),d6 ; max sections
	beq.s	ber_cysc		; none
	jsr	bed_rcdf(pc)		; return current state
	bne.s	ber_exit
	addq.l	#8,a3
ber_cysc
	move.l	wwa_part+wwa.clen(a4),a1
	move.w	wwa_nysc(a4),d6
	beq.s	ber_apre
	jsr	bed_rcdf(pc)		; same for y
	bne.s	ber_exit
	addq.l	#8,a3
*
ber_apre
	dbra	d7,ber_appw		; and do the next one
*
ber_exok
	moveq	#0,d0
ber_exit
	adda.w	#16,sp		; pop the NT pointers
	rts
ber_exbp
	moveq	#err.ipar,d0
	bra.s	ber_exit
*
*	Assign TOS to TONT, and advance the pointers to the next entries
*	It is assumed that the entries are integers.
*
letreg	reg	a2/a4
ber_ld0
	subq.l	#2,a1
	move.l	a1,bv_rip(a6)
	move.w	d0,0(a6,a1.l)
ber_let
	movem.l letreg,-(sp)
	move.l	a1,a4
	move.w	bp.let,a2
	jsr	(a2)		; assign to current variable
	lea	2(a4),a1		; point to next value
	addq.l	#8,a3		; and next variable
	tst.l	d0
	movem.l (sp)+,letreg
	bne.s	bel_bad 	; error, do a funny return
	rts
bel_bad
	addq.l	#4,sp		; pop return address
	bra.s	ber_exit
*
	end
