*	Read pointer from SuperBASIC	v0.00   1987 J.R.Oakley
*
*	RPTR [#ch,]xabs%,yabs%,term%,sw%,xrel%,yrel%,button$
*
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_qdos_pt'
	include 'dev1_asm_qptr_keys'
*
	xref	ut_getch
*
	xdef	be_rptr
*
be_rptr
	moveq	#24+16,d1
	move.w	bv.chrix,a2
	jsr	(a2)		; ensure there's space for ptr record
*
	jsr	ut_getch(pc)		; get the channel ID to A4
	sub.w	#3*8,a5 	; don't get last three parameters
	move.w	ca.gtint,a2		; all parameters are integers
	jsr	(a2)
	bne	ber_exit		; ...oops
	subq.w	#4,d3		; must be exactly four
	bne	ber_exip		; ...oops
*
	move.l	0(a6,a1.l),d1	; get expected position
	move.w	4(a6,a1.l),d7	; and termination conditions
	move.w	6(a6,a1.l),d6	; and current sub-window
	sub.w	#24,a1		; use RI stack for pointer record
	move.w	d7,d2
**** wl
	clr.b	d2		; get rid of wdw events
	swap	d2		: d2.h = job events
	clr.w	d2
	move.b	d7,d2		; wdw events
**** end wl
	btst	#be..outsw,d7	; terminate on "out of sub-window"?
	beq.s	ber_srec		; no, set up pointer record
ber_loop
	moveq	#err.nc,d0		; assume not complete
	tst.b	bv_brk(a6)		; has there been a break?
	beq.s	ber_exit		; yes, stop now
	move.w	d7,d2		; set termination conditions
	or.b	#pt.move,d2		; but terminate on move, as well
*
ber_srec
	moveq	#-1,d3
	move.l	a4,a0		; get channel ID
	moveq	#iop.rptr,d0		; read pointer
	trap	#4			; with A1 A6-relative
	trap	#3
	tst.l	d0			; OK?
	beq.s	ber_retr		; yes, return results
	cmp.l	#err.nc,d0		; not complete?
	bne.s	ber_exit		; no, real error
	bset	#7,pp_event+2(a6,a1.l)	; yes, set NC flag
*
ber_retr
	cmp.w	pp_sbwnr(a6,a1.l),d6	; same sub-window as before?
	beq.s	ber_tstr		; yes, no need to return
	bset	#be..outsw-8,pp_event+2(a6,a1.l) ; no, set bit
*
ber_tstr
	move.w	pp_event(a6,a1.l),d0  ; get reason for return

**** wl
	move.b	pp_event+3(a6,a1.l),d0
**** end wl
	and.w	d7,d0		; was that wanted?
	beq.s	ber_loop		; no, move was added by "outsw"
*
	move.l	a1,a4		; keep pointer to record
	move.l	d1,pp_subdf(a6,a4.l)	; smash absolute position into record
*
	lea	pp_subdf(a4),a1 ; point to X position
	bsr.s	ber_let 	; save it
	lea	pp_subdf+2(a4),a1	; same for Y position
	bsr.s	ber_let
	lea	pp_event+2(a4),a1	; and event vector
**** wl
	move.b	-2(a6,a1.l),(a6,a1.l)
***end wl
	bsr.s	ber_let
	lea	pp_sbwnr(a4),a1 ; and sub-window number
	bsr.s	ber_let
*
	lea	pp_xpos(a4),a1	; and relative X position
	bsr.s	ber_let
	lea	pp_ypos(a4),a1	; and Y
	bsr.s	ber_let
	move.w	#1,pp_kstrk-2(a6,a4.l)	; length of string
	lea	pp_kstrk-2(a4),a1	; set button
	bsr.s	ber_let
*
ber_exit
	rts
ber_exip
	moveq	#err.ipar,d0
	bra.s	ber_exit
*
ber_let
	move.w	bp.let,a2
	move.l	a1,bv_rip(a6)	; set RI stack pointer
	jsr	(a2)		; assign to a variable
	addq.l	#8,a3		; point to next variable
	rts
*
	end
