* Set a sub-window definition
*
*	SWDEF [#ch,]swnum,xsize,ysize,xorg,yorg[,sprite]
*
*
	section prog
*
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_con'
	include 'dev8_keys_err'
	include 'dev8_keys_qlv'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_qdos_pt'
*
	xref	ut_getch
*
	xdef	be_swdef
	xdef	ut_fswdf
*
ri.swnum equ	0
ri.swxsz equ	6
ri.swysz equ	10
ri.swxor equ	14
ri.swyor equ	18
ri.swspt equ	20
*
be_swdef
	jsr	ut_getch(pc)		; get a channel ID
	move.w	ca.gtlin,a2		; and some long integers
	jsr	(a2)
	tst.l	d0
	bne.s	bes_exit		; ...oops
	tst.l	d3			; any other parameters?
	beq.s	bes_clra		; no, remove all definitions
*
	subq.l	#1,d3		; just one parameter?
	beq.s	bes_clrd		; yes, remove that definition
	moveq	#0,d1		; assume there's no sprite
	subq.w	#4,d3		; must be at least four parameters
	blt.s	bes_exbp		; ...oops
**** wl
	beq.s	bes_slnk		; five, no sprite
***** end wl
	move.l	ri.swspt(a6,a1.l),d1	; point to sprite

***** wl
bes_slnk
	move.l	a4,a0
	move.l	a1,a4
	moveq	#0,d2
	moveq	#-1,d3
	moveq	#iop.slnk,d0
	trap	#3
	move.l	$f2(a1),d2
	move.l	a4,a1
*
*	Now use an EXTOP to set the new sub-window
*
bes_stsw
;	 moveq	 #-1,d3
	lea	bex_ntry(pc),a2
;	 move.l  a4,a0

**** end wl

	moveq	#iow.xtop,d0
	trap	#4
	trap	#3
*
bes_exit
	tst.l	d0
	rts
bes_exbp
	moveq	#err.ipar,d0
	bra.s	bes_exit
*
*	Come here to clear a single sub-window definition
*
bes_clrd
	move.l	0(a6,a1.l),d1	; set sub-window to clear
	moveq	#-1,d3
	lea	bec_ntry(pc),a2 ; use EXTOP to do it
	move.l	a4,a0
	moveq	#iow.xtop,d0
	trap	#3
	bra.s	bes_exit
*
*	Come here to clear out all sub-window definitions
*
bes_clra
	moveq	#-1,d3
	lea	bea_ntry(pc),a2
	move.l	a4,a0
	moveq	#iow.xtop,d0
	trap	#3
	bra.s	bes_exit
*
*	Extended operation to clear out all sub-windows
*
clrreg	reg	a0/a2-a4
bea_ntry
	movem.l clrreg,-(sp)
	move.l	a0,a4
	move.l	sd_wwdef(a4),a3 ; point to main window definition
	move.l	a3,d0
	beq.s	bea_exit		; none, do nuffin
	move.l	a3,a0		; we'll return this in a moment
	move.l	(a3),a3 	; the table is here
	sub.w	#$10,a0
	bsr	bes_rehp		; return main defn
*
	move.l	a3,d0		; is there a table?
	beq.s	bea_exit		; no, finished then
	move.l	-4(a3),d1		; yes, number of entries
	move.l	a3,a2		; smashable pointer
	bra.s	bea_rete
bea_retl
	move.l	(a2)+,d0		; next definition
	beq.s	bea_rete		; none
	move.l	d0,a0
	sub.w	#$10,a0
	bsr	bes_rehp		; return it
bea_rete
	dbra	d1,bea_retl		; do next one
*
	lea	-$14(a3),a0		; point to table
	bsr	bes_rehp		; and return that
*
bea_exit
	clr.l	sd_wwdef(a4)		; no sub-windows now
	moveq	#0,d0		; no errors possible
	movem.l (sp)+,clrreg
	rts
*
*	Extended operation to clear a sub-window definition
*
cl1reg	reg	d1/a0/a3
bec_ntry
	movem.l cl1reg,-(sp)
	bsr.s	ut_fswdf		; find the sub-window definition
	bne.s	bec_exit		; failed, done then
	tst.l	d1			; clearing main definition?
	bmi.s	bec_clrm		; yes, ho hum
*
	lea	-$10(a1),a0		; point to start of heap item
	bsr	bes_rehp		; return it
	clr.l	(a3)		; clear entry in table
bec_exit
	moveq	#0,d0		; can't fail
	movem.l (sp)+,cl1reg
	rts
*
*	Come here to clear main definition: for now we clear the sprite and
*	set the definition to the main area.
*
bec_clrm
	clr.l	sw_psprt(a1)		; no sprite now
	move.l	sd_xsize(a0),sw_xsize(a1)
	move.l	sd_xmin(a0),sw_xorg(a1) ; size and origin are as for main area
	bra.s	bec_exit
*
*	Utility to find a sub-window from its number
*
*	Registers:
*	      Entry			Exit
*	D0				0 or err.itnf
*	D1	sub-window number		preserved
*	A0	pointer to cdb		preserved
*	A1				pointer to sub-window record
*	A3				pointer to table entry
*
ut_fswdf
	move.l	sd_wwdef(a0),a3 ; point to main entry
	move.l	a3,d0		; is there one?
	beq.s	bef_exnf		; no, not found
	tst.l	d1			; finding main definition?
	bmi.s	bef_mdef		; yes, ho hum
*
	move.l	(a3),a3 	; point to table
	move.l	a3,d0		; is there one?
	beq.s	bef_exnf		; no, not found again
*
	cmp.l	-4(a3),d1		; is the sub-window in the table?
	bhi.s	bef_exnf		; nope, what a wally
	move.l	d1,d0
	add.l	d0,d0
	add.l	d0,d0		; point to entry
	add.l	d0,a3
	move.l	(a3),a1 	; and to definition
	move.l	a1,d0		; is it there?
	beq.s	bef_exnf		; no, wow
bef_exok
	moveq	#0,d0
bef_exit
	rts
bef_exnf
	moveq	#err.itnf,d0		; sub-window not found
	bra.s	bef_exit
bef_mdef
	lea	4(a3),a1		; point to "main" sub-window
	bra.s	bef_exok
*
*	Extended operation to set a sub-window definition
*
bexreg	reg	d1/a0-a4
*
bex_exor
	moveq	#err.orng,d0
	bra.l	bex_exit
*
bex_ntry
	movem.l bexreg,-(sp)
	move.l	a0,a4		; keep cdb safe
	move.l	d1,d4		; and pointer to sprite
*

***** wl
	sub.w	$12(a1),d2
	bmi.s	bex_exor
	sub.w	10(a1),d2
	bmi.s	bex_exor
	swap	d2
	sub.w	$e(a1),d2
	bmi.s	bex_exor
	sub.w	6(a1),d2
	bmi.s	bex_exor

;	 move.w  #$200,d0		 ; get max x size
;	 sub.w	 ri.swxor(a1),d0 ; is origin on screen?
;	 bmi.s	 bex_exor		 ; no
;	 sub.w	 ri.swxsz(a1),d0 ; is there room for the size?
;	 bmi.s	 bex_exor		 ; no
*
;	 move.w  #$100,d0		 ; get max y size
;	 sub.w	 ri.swyor(a1),d0 ; is origin on screen?
;	 bmi.s	 bex_exor		 ; no
;	 sub.w	 ri.swysz(a1),d0 ; is there room for the size?
;	 bmi.s	 bex_exor		 ; no

***end wl

*
	move.l	sd_wwdef(a4),d0 ; point to sub-window list
	bne.s	bex_fswn		; there is one already
*
*	Pass through this bit if there's no sub-windows yet
*
	moveq	#sw.defl+4,d1	   ; allocate for main part of window
	bsr	bes_alhp
	bne	bex_exit		   ; ...oops
	add.w	#$10,a0 	   ; point to usable bit
	move.l	a0,sd_wwdef(a4)    ; fill in pointer to it
	move.l	sd_xsize(a4),sw_xsize+4(a0)
	move.l	sd_xmin(a4),sw_xorg+4(a0)  ; size and origin as for main area
	move.l	a0,d0
*
bex_fswn
	move.l	d0,a3		; point to main window definition
	move.l	(a1),d2 	; get sub-window number to set
	bpl.s	bex_cmpn		; not main window, see if it's in list
	lea	4(a3),a0		; point to (existing) main definition
	bra.s	bex_sdef		; and set it
*
bex_cmpn
	move.l	(a3),a2 	; point to table
	move.l	a2,d1
	bne.s	bex_ckln		; there is one, see if it's long enough
	move.l	d2,d1		; there isn't, make one just big enough
	bra.s	bex_mknl		; and allocate the space
bex_ckln
	cmp.l	-4(a2),d2		; is it long enough to contain the sw?
	blt.s	bex_gswp		; yes
*
*	Come here if the existing table isn't big enough, and decide how
*	big the new table should be
*
	move.l	-4(a2),d1		; current number of sub-windows
	add.l	d1,d1		; double it
	cmp.l	d1,d2		; would that be enough?
	blt.s	bex_mknl		; yes, make a new list that long
	move.l	d2,d1		; no, make list just big enough
bex_mknl
	addq.l	#2,d1		; extra entry for sw count and 0
	add.l	d1,d1
	add.l	d1,d1		; make up to long words
	bsr.s	bes_alhp		; allocate
	bne.s	bex_exit		; ...oops
*
*	Fill in new sub-window table with number of entries allowed, and
*	pointers to existing entries in the old table.
*
	moveq	#$10,d0
	add.l	d0,a0		; point to usable bit
	sub.l	d0,d1		; and set its length
	asr.l	#2,d1		; number of entries possible...
	subq.l	#2,d1		; ...is this
	move.l	d1,(a0)+		; fill it in
	move.l	a0,(a3) 	; point to new table
	move.l	a2,d0		; save pointer to old table
	beq.s	bex_gswp		; there isn't one, don't copy
	move.l	-4(a2),d1		; number of entries to copy
	bra.s	bex_cple
bex_cplp
	move.l	(a2)+,(a0)+		; copy pointer to existing sub-window
bex_cple
	dbra	d1,bex_cplp
*
	move.l	d0,a0		; point to old table
	sub.w	#$14,a0 	; start of heap entry
	bsr.s	bes_rehp		; return it
*
*	Now get the sub-window pointer from the table: A2 points to the
*	table, and D2 is the sub-window we want to set.
*
bex_gswp
	move.l	(a3),a2 	; point to sub-window table
	add.l	d2,d2
	add.l	d2,d2		; make sw number into offset
	move.l	0(a2,d2.l),a0	; get pointer to sub-window
	move.l	a0,d0		; is there one?
	bne.s	bex_sdef		; yes, reset the definition
*
	moveq	#sw.defl,d1		; allocate space for new sub-window
	bsr.s	bes_alhp
	bne.s	bex_exit		; ...oops
	add.w	#$10,a0
	move.l	a0,0(a2,d2.l)	; fill in pointer
*
bex_sdef
	movem.l 4(a1),d0-d3		; get sub-window size
	movem.w d0-d3,(a0)		; fill that in
	move.l	d4,sw_psprt(a0) ; and sprite pointer
	moveq	#0,d0		; there's no error
*
bex_exit
	movem.l (sp)+,bexreg
	rts
*
*	Come here to allocate heap
*
alhpreg reg	d2/d3/a1-a3
bes_alhp
	movem.l alhpreg,-(sp)
	moveq	#$10,d0 	; allow for header
	add.l	d0,d1
	move.w	mem.achp,a2
	jsr	(a2)
	tst.l	d0
	movem.l (sp)+,alhpreg
	rts
*
rehpreg reg	d1-d3/a0-a3
bes_rehp
	movem.l rehpreg,-(sp)
	move.w	mem.rchp,a2
	jsr	(a2)
	movem.l (sp)+,rehpreg
	rts
*
	end
